//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "InteresectSegments0.h"
#include <stdlib.h>
#include <math.h>

using namespace std;
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------
struct Vector3D
{ double x,y,z;
};
double min(double x, double y)
{ if ( x>y ) return y;
  else return x;
}
double max(double x, double y)
{ if ( x>y ) return x;
  else return y;
}
Vector3D v1[2], v2[2];
Vector3D r1,r2,p1,p2,u1,u2;
double s, t;
double epsilon = 1E-10;
double value[] = {1,0,0, 0,1,0, 0,0,1, 0,1,0 };
//double value[] = {1,0,0, 0,1,0, 0.5,0,0, 0,0.5,0 };

void assignVector()
{ v1[0].x = p1.x = value[0];
  v1[0].y = p1.y = value[1];
  v1[0].z = p1.z = value[2];
  v1[1].x = value[3];
  v1[1].y = value[4];
  v1[1].z = value[5];
  v2[0].x = p2.x = value[6];
  v2[0].y = p2.y = value[7];
  v2[0].z = p2.z = value[8];
  v2[1].x = value[9];
  v2[1].y = value[10];
  v2[1].z = value[11];
}

void __fastcall TForm1::Button1Click(TObject *Sender)
{ AnsiString msg;
  double delta;
assignVector();
  u1.x = v1[1].x-v1[0].x;
  u1.y = v1[1].y-v1[0].y;
  u1.z = v1[1].z-v1[0].z;
  u2.x = v2[1].x-v2[0].x;
  u2.y = v2[1].y-v2[0].y;
  u2.z = v2[1].z-v2[0].z;
  // overlap?

  if ( fabs(u1.x*u2.y-u1.y*u2.x)<epsilon &&      // parallel case
       fabs(u1.y*u2.z-u1.z*u2.y)<epsilon ) //&&
       //abs(u1.x*u2.z-u1.z*u2.x)<epsilon  )
    { if ( fabs(u1.x*(v2[0].y-v1[0].y)-u1.y*(v2[0].x-v1[0].x))<epsilon &&  // on same line
           fabs(u1.y*(v2[0].z-v1[0].z)-u1.z*(v2[0].y-v1[0].y))<epsilon    )
        { if ( ( min(v1[0].x, v1[1].x)<=v2[0].x && v2[0].x<=max(v1[0].x, v1[1].x) ) ||
               ( min(v1[0].x, v1[1].x)<=v2[1].x && v2[1].x<=max(v1[0].x, v1[1].x) )    )
            { msg.printf("They overlap!");
            }
        }
      else
        msg.printf("They are separately parallel (//).");
    }
  else // find s and t.
    { delta = u1.y*u2.x - u1.x*u2.y;
      s = ( u2.x*(p2.y-p1.y) - u2.y*(p2.x-p1.x) ) / delta;
      t = ( u1.x*(p2.y-p1.y) - u1.y*(p2.x-p1.x) ) / delta;
      
      if ( fabs( p1.z+s*u1.z - (p2.z+t*u2.z) ) < epsilon )
        { if ( 0.<=s && s<=1. && 0.<=t && t<=1. )
            { // get the intersectional point
              msg.printf("They intersect at a point!");
            }
          else
            { msg.printf("They don't intersect!");
            }
        }
      else
        msg.printf("They don't intersect!");
    }
  ShowMessage(msg);  
}
//---------------------------------------------------------------------------
